<template>
	<div>
		<v-card height="65vh" id="formCard">
			<v-row>
				<v-btn icon class="mt-5 mr-3" @click="$emit('closeForm')">
					<v-icon>mdi-close</v-icon>
				</v-btn>
				<h1 class="text-center pt-5 pr-8">הגדרת ערך הסף</h1>
			</v-row>

			<v-row justify="center">
				<v-col cols="6">
					<v-text-field
						:rules="numberRules"
						v-for="(threshold, index) in orgThresholdArray"
						:key="index"
						type="number"
						min="0"
						:label="getDateName(threshold.day)"
						:value="threshold.threshold"
						v-model="orgThresholdArray[index].threshold"
					></v-text-field>
				</v-col>
			</v-row>
			<v-row justify="center">
				<v-btn
					elevation="2"
					outlined
					rounded
					class="mt-2 mr-3"
					id="button"
					@click="this.updateThresholdArray"
					>עדכן</v-btn
				>
			</v-row>
		</v-card>
	</div>
</template>

<script>
import datesNames from 'date-names';
import api from '../api';

export default {
	name: 'thresholdForm',
	created() {
		this.getThreshold();
	},
	data() {
		return {
			orgThresholdArray: [],
			numberRules: [v => v >= 0 || 'מספר גדול מ-0'],
		};
	},
	methods: {
		getDateName(day) {
			return datesNames.abbreviated_days[day];
		},
		getThreshold() {
			api.reports
				.allThresholds()
				.then(res => {
					this.orgThresholdArray = res.data;
				})
				.then(() => {
					for (let index = 0; index < 7; index++) {
						this.models[index] = this.orgThresholdArray[index].threshold;
					}
				});
		},
		async updateThresholdArray() {
			const thresholdArray = [];
			this.orgThresholdArray.forEach(threshold =>
				thresholdArray.push(parseInt(threshold.threshold)),
			);
			await api.reports.updateThresholds(thresholdArray);
			this.$emit('closeForm');
		},
	},
};
</script>

<style scoped>
#formCard {
	background-color: #dfeeea;
	opacity: 0.95;
}
</style>
